'use strict'
var safeStringify = require('fast-safe-stringify')
var JSONStream = require('json-stream')
var util = require('util')
var EventEmitter = require('events').EventEmitter
var flat = require('flat')
var async = require('async')

function getAll (core, ext, resource, cb) {
  core.ns.get((err, res) => {
  if (err) return cb(err)
  async.map(
    res.items,
    (obj, next) => ext.ns(obj.metadata.name).kind(resource).get(next),
    cb)
  })
}

  

/**
 * Constructor called by logagent
 * @config cli arguments and config entries
 * @eventEmitter logent eventEmitter object
 */
function Kubernetes (config, eventEmitter) {
  this.config = config
  this.eventEmitter = eventEmitter
}
module.exports = InputElasticsearchQuery
/**
 * Plugin start function, called after constructor
 *
 */
Kubernetes.prototype.start = function () {
  if (!this.started) {
    this.started = true
    var self = this
    this = null
    var core = null
    var self = this
    var extensions = null

  if (process.env.KUBERNETES_PORT_443_TCP) {
    Api = require('kubernetes-client')
    core = new Api.Core(Api.config.getInCluster())
  } else {
    Api = require('kubernetes-client')
    core = new Api.Core(Api.config.fromKubeconfig())
    extensions = new Api.Extensions(Api.config.fromKubeconfig())
  }

    var runQuery = function () {
      self.query()
    }
    if (this.config.interval && this.config.interval > 0) {
      this.tid = setInterval(runQuery, this.config.interval * 1000)
    }
    runQuery()

  }
}

/**
 * Plugin stop function, called when logagent terminates
 * we close the server socket here.
 */
Kubernetes.prototype.stop = function (cb) {
  if (this.config.tid) {
    clearInterval(this.tid)
  }
}

Kubernetes.prototype.runQuery () {
  var self = this
  getAll(ext, 'deployments', (err, res) => {
    if (!err && res) {
      self.eventEmitter.emit('data.raw', safeStringify(res), context)
    }
  })
}
